Index: src/language/stats/crosstabs.q
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/crosstabs.q,v
retrieving revision 1.23
diff -u -p -r1.23 crosstabs.q
--- src/language/stats/crosstabs.q	25 Nov 2006 02:15:01 -0000	1.23
+++ src/language/stats/crosstabs.q	5 Dec 2006 06:36:48 -0000
@@ -593,25 +593,24 @@ calc_general (const struct ccase *c, voi
 	for (j = 0; j < x->nvar; j++)
 	  {
             const union value *v = case_data (c, x->vars[j]->fv);
-            const struct missing_values *mv = &x->vars[j]->miss;
-	    if ((cmd.miss == CRS_TABLE && mv_is_value_missing (mv, v))
+	    if ((cmd.miss == CRS_TABLE && var_is_value_missing (x->vars[j], v))
 		|| (cmd.miss == CRS_INCLUDE
-		    && mv_is_value_system_missing (mv, v)))
+		    && var_is_value_system_missing (x->vars[j], v)))
 	      {
 		x->missing += weight;
 		goto next_crosstab;
 	      }
 	      
-	    if (x->vars[j]->type == NUMERIC)
+	    if (var_is_numeric (x->vars[j]))
 	      te->values[j].f = case_num (c, x->vars[j]->fv);
 	    else
 	      {
 		memcpy (te->values[j].s, case_str (c, x->vars[j]->fv),
-                        x->vars[j]->width);
+                        var_get_width (x->vars[j]));
 	      
 		/* Necessary in order to simplify comparisons. */
-		memset (&te->values[j].s[x->vars[j]->width], 0,
-			sizeof (union value) - x->vars[j]->width);
+		memset (&te->values[j].s[var_get_width (x->vars[j])], 0,
+			sizeof (union value) - var_get_width (x->vars[j]));
 	      }
 	  }
       }
@@ -666,8 +665,7 @@ calc_integer (const struct ccase *c, voi
 	  
 	  /* Note that the first test also rules out SYSMIS. */
 	  if ((value < vr->min || value >= vr->max)
-	      || (cmd.miss == CRS_TABLE
-                  && mv_is_num_user_missing (&v->miss, value)))
+	      || (cmd.miss == CRS_TABLE && var_is_num_user_missing (v, value)))
 	    {
 	      x->missing += weight;
 	      goto next_crosstab;
@@ -716,7 +714,7 @@ compare_table_entry (const void *a_, con
     int i;
 
     for (i = x->nvar - 1; i >= 0; i--)
-      if (x->vars[i]->type == NUMERIC)
+      if (var_is_numeric (x->vars[i]))
 	{
 	  const double diffnum = a->values[i].f - b->values[i].f;
 	  if (diffnum < 0)
@@ -725,15 +723,12 @@ compare_table_entry (const void *a_, con
 	    return 1;
 	}
       else 
-	{
-	  assert (x->vars[i]->type == ALPHA);
-	  {
-	    const int diffstr = strncmp (a->values[i].s, b->values[i].s,
-                                         x->vars[i]->width);
-	    if (diffstr)
-	      return diffstr;
-	  }
-	}
+        {
+          const int diffstr = strncmp (a->values[i].s, b->values[i].s,
+                                       var_get_width (x->vars[i]));
+          if (diffstr)
+            return diffstr;
+        }
   }
   
   return 0;
@@ -902,8 +897,7 @@ insert_summary (struct tab_table *t, int
 	if (i > 0)
 	  cp = stpcpy (cp, " * ");
 
-	cp = stpcpy (cp,
-                     x->vars[i]->label ? x->vars[i]->label : x->vars[i]->name);
+	cp = stpcpy (cp, var_to_string (x->vars[i]));
       }
     tab_text (t, 0, 0, TAB_LEFT, buf);
 
@@ -1010,7 +1004,7 @@ output_pivot_table (struct table_entry *
 
       /* First header line. */
       tab_joint_text (table, nvar - 1, 0, (nvar - 1) + (n_cols - 1), 0,
-		      TAB_CENTER | TAT_TITLE, x->vars[COL_VAR]->name);
+		      TAB_CENTER | TAT_TITLE, var_get_name (x->vars[COL_VAR]));
   
       tab_hline (table, TAL_1, nvar - 1, nvar + n_cols - 2, 1);
 	     
@@ -1020,11 +1014,9 @@ output_pivot_table (struct table_entry *
 
 	for (i = 2; i < nvar; i++)
 	  tab_joint_text (table, nvar - i - 1, 0, nvar - i - 1, 1,
-			  TAB_RIGHT | TAT_TITLE,
-			  (x->vars[i]->label
-                           ? x->vars[i]->label : x->vars[i]->name));
+			  TAB_RIGHT | TAT_TITLE, var_to_string (x->vars[i]));
 	tab_text (table, nvar - 2, 1, TAB_RIGHT | TAT_TITLE,
-		  x->vars[ROW_VAR]->name);
+		  var_get_name (x->vars[ROW_VAR]));
 	for (i = 0; i < n_cols; i++)
 	  table_value_missing (table, nvar + i - 1, 1, TAB_RIGHT, &cols[i],
 			       x->vars[COL_VAR]);
@@ -1045,12 +1037,13 @@ output_pivot_table (struct table_entry *
 	    {
 	      if (i)
 		cp = stpcpy (cp, " by ");
-	      cp = stpcpy (cp, x->vars[i]->name);
+	      cp = stpcpy (cp, var_get_name (x->vars[i]));
 	    }
 	else
 	  {
 	    cp = spprintf (cp, "%s by %s for",
-                           x->vars[0]->name, x->vars[1]->name);
+                           var_get_name (x->vars[0]),
+                           var_get_name (x->vars[1]));
 	    for (i = 2; i < nvar; i++)
 	      {
 		char buf[64], *bufp;
@@ -1058,9 +1051,10 @@ output_pivot_table (struct table_entry *
 		if (i > 2)
 		  *cp++ = ',';
 		*cp++ = ' ';
-		cp = stpcpy (cp, x->vars[i]->name);
+		cp = stpcpy (cp, var_get_name (x->vars[i]));
 		*cp++ = '=';
-		format_short (buf, &x->vars[i]->print, &(*pb)->values[i]);
+		format_short (buf, var_get_print_format (x->vars[i]),
+                              &(*pb)->values[i]);
 		for (bufp = buf; isspace ((unsigned char) *bufp); bufp++)
 		  ;
 		cp = stpcpy (cp, bufp);
@@ -1429,7 +1423,7 @@ delete_missing (void)
     int r;
 
     for (r = 0; r < n_rows; r++)
-      if (mv_is_num_user_missing (&x->vars[ROW_VAR]->miss, rows[r].f))
+      if (var_is_num_user_missing (x->vars[ROW_VAR], rows[r].f))
 	{
 	  int c;
 
@@ -1443,7 +1437,7 @@ delete_missing (void)
     int c;
 
     for (c = 0; c < n_cols; c++)
-      if (mv_is_num_user_missing (&x->vars[COL_VAR]->miss, cols[c].f))
+      if (var_is_num_user_missing (x->vars[COL_VAR], cols[c].f))
 	{
 	  int r;
 
@@ -1473,7 +1467,7 @@ submit (struct tab_table *t)
   if (t != table)
     for (i = 2; i < nvar; i++)
       tab_text (t, nvar - i - 1, 0, TAB_RIGHT | TAT_TITLE,
-		x->vars[i]->label ? x->vars[i]->label : x->vars[i]->name);
+                var_to_string (x->vars[i]));
   tab_box (t, TAL_2, TAL_2, -1, -1, 0, 0, tab_nc (t) - 1, tab_nr (t) - 1);
   tab_box (t, -1, -1, -1, TAL_1, tab_l (t), tab_t (t) - 1, tab_nc (t) - 1,
 	   tab_nr (t) - 1);
@@ -1641,7 +1635,7 @@ enum_var_values (struct table_entry **en
 
   if (mode == GENERAL)
     {
-      int width = v->width;
+      int width = var_get_width (v);
       int i;
 
       *values = xnmalloc (entry_cnt, sizeof **values);
@@ -1671,6 +1665,7 @@ table_value_missing (struct tab_table *t
 		     const union value *v, const struct variable *var)
 {
   struct substring s;
+  const struct fmt_spec *print = var_get_print_format (var);
 
   const char *label = val_labs_find (var->val_labs, *v);
   if (label) 
@@ -1679,10 +1674,10 @@ table_value_missing (struct tab_table *t
       return;
     }
 
-  s.string = tab_alloc (table, var->print.w);
-  format_short (s.string, &var->print, v);
+  s.string = tab_alloc (table, print->w);
+  format_short (s.string, print, v);
   s.length = strlen (s.string);
-  if (cmd.miss == CRS_REPORT && mv_is_num_user_missing (&var->miss, v->f))
+  if (cmd.miss == CRS_REPORT && var_is_num_user_missing (var, v->f))
     s.string[s.length++] = 'M';
   while (s.length && *s.string == ' ')
     {
@@ -1765,9 +1760,8 @@ display_crosstabulation (void)
             bool mark_missing = false;
             double expected_value = row_tot[r] * col_tot[c] / W;
             if (cmd.miss == CRS_REPORT
-                && (mv_is_num_user_missing (&x->vars[COL_VAR]->miss, cols[c].f)
-                    || mv_is_num_user_missing (&x->vars[ROW_VAR]->miss,
-                                               rows[r].f)))
+                && (var_is_num_user_missing (x->vars[COL_VAR], cols[c].f)
+                    || var_is_num_user_missing (x->vars[ROW_VAR], rows[r].f)))
               mark_missing = true;
 	    for (i = 0; i < num_cells; i++)
 	      {
@@ -1831,7 +1825,7 @@ display_crosstabulation (void)
         bool mark_missing = false;
 
         if (cmd.miss == CRS_REPORT
-            && mv_is_num_user_missing (&x->vars[ROW_VAR]->miss, rows[r].f))
+            && var_is_num_user_missing (x->vars[ROW_VAR], rows[r].f))
           mark_missing = true;
 
         for (i = 0; i < num_cells; i++)
@@ -1886,7 +1880,7 @@ display_crosstabulation (void)
         int i;
 	    
         if (cmd.miss == CRS_REPORT && c < n_cols 
-            && mv_is_num_user_missing (&x->vars[COL_VAR]->miss, cols[c].f))
+            && var_is_num_user_missing (x->vars[COL_VAR], cols[c].f))
           mark_missing = true;
 
         for (i = 0; i < num_cells; i++)
@@ -2082,24 +2076,24 @@ display_risk (void)
       switch (i)
 	{
 	case 0:
-	  if (x->vars[COL_VAR]->type == NUMERIC)
+	  if (var_is_numeric (x->vars[COL_VAR]))
 	    sprintf (buf, _("Odds Ratio for %s (%g / %g)"),
-		     x->vars[COL_VAR]->name, c[0].f, c[1].f);
+		     var_get_name (x->vars[COL_VAR]), c[0].f, c[1].f);
 	  else
 	    sprintf (buf, _("Odds Ratio for %s (%.*s / %.*s)"),
-		     x->vars[COL_VAR]->name,
-		     x->vars[COL_VAR]->width, c[0].s,
-		     x->vars[COL_VAR]->width, c[1].s);
+		     var_get_name (x->vars[COL_VAR]),
+		     var_get_width (x->vars[COL_VAR]), c[0].s,
+		     var_get_width (x->vars[COL_VAR]), c[1].s);
 	  break;
 	case 1:
 	case 2:
-	  if (x->vars[ROW_VAR]->type == NUMERIC)
+	  if (var_is_numeric (x->vars[ROW_VAR]))
 	    sprintf (buf, _("For cohort %s = %g"),
-		     x->vars[ROW_VAR]->name, rows[i - 1].f);
+		     var_get_name (x->vars[ROW_VAR]), rows[i - 1].f);
 	  else
 	    sprintf (buf, _("For cohort %s = %.*s"),
-		     x->vars[ROW_VAR]->name,
-		     x->vars[ROW_VAR]->width, rows[i - 1].s);
+		     var_get_name (x->vars[ROW_VAR]),
+		     var_get_width (x->vars[ROW_VAR]), rows[i - 1].s);
 	  break;
 	}
 		   
@@ -2208,15 +2202,15 @@ display_directional (void)
 	      
 	      for (; j < 3; j++)
 		{
-		  char *string;
+		  const char *string;
 		  int k = last[j] = stats_lookup[j][i];
 
 		  if (k == 0)
 		    string = NULL;
 		  else if (k == 1)
-		    string = x->vars[0]->name;
+		    string = var_get_name (x->vars[0]);
 		  else
-		    string = x->vars[1]->name;
+		    string = var_get_name (x->vars[1]);
 		  
 		  tab_text (direct, j, 0, TAB_LEFT | TAT_PRINTF,
 			    gettext (stats_names[j][k]), string);
@@ -2386,7 +2380,7 @@ calc_chisq (double chisq[N_CHISQ], int d
     }
 
   /* Calculate Mantel-Haenszel. */
-  if (x->vars[ROW_VAR]->type == NUMERIC && x->vars[COL_VAR]->type == NUMERIC)
+  if (var_is_numeric (x->vars[ROW_VAR]) && var_is_numeric (x->vars[COL_VAR]))
     {
       double r, ase_0, ase_1;
       calc_r ((double *) rows, (double *) cols, &r, &ase_0, &ase_1);
Index: src/language/stats/descriptives.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/descriptives.c,v
retrieving revision 1.17
diff -u -p -r1.17 descriptives.c
--- src/language/stats/descriptives.c	11 Nov 2006 23:10:00 -0000	1.17
+++ src/language/stats/descriptives.c	5 Dec 2006 06:36:49 -0000
@@ -378,7 +378,8 @@ cmd_descriptives (struct lexer *lexer, s
             if (dsc->vars[i].z_name[0] == 0) 
               {
                 if (!generate_z_varname (dict, dsc, dsc->vars[i].z_name,
-                                         dsc->vars[i].v->name, &gen_cnt))
+                                         var_get_name (dsc->vars[i].v),
+                                         &gen_cnt))
                   goto error;
                 z_cnt++;
               } 
@@ -567,7 +568,7 @@ dump_z_table (struct dsc_proc *dsc)
     for (i = 0, y = 1; i < dsc->var_cnt; i++)
       if (dsc->vars[i].z_name[0] != '\0')
 	{
-	  tab_text (t, 0, y, TAB_LEFT, dsc->vars[i].v->name);
+	  tab_text (t, 0, y, TAB_LEFT, var_get_name (dsc->vars[i].v));
 	  tab_text (t, 1, y++, TAB_LEFT, dsc->vars[i].z_name);
 	}
   }
@@ -598,7 +599,7 @@ descriptives_trns_proc (void *trns_, str
 	  double score = case_num (c, (*vars)->fv);
 	  if ( score == SYSMIS
                || (!t->include_user_missing 
-                   && mv_is_num_user_missing (&(*vars)->miss, score)))
+                   && var_is_num_user_missing (*vars, score)))
 	    {
 	      all_sysmis = 1;
 	      break;
@@ -614,7 +615,7 @@ descriptives_trns_proc (void *trns_, str
       if (z->mean == SYSMIS || z->std_dev == SYSMIS 
 	  || all_sysmis || input == SYSMIS 
 	  || (!t->include_user_missing
-              && mv_is_num_user_missing (&z->v->miss, input)))
+              && var_is_num_user_missing (z->v, input)))
 	*output = SYSMIS;
       else
 	*output = (input - z->mean) / z->std_dev;
@@ -669,22 +670,11 @@ setup_z_trns (struct dsc_proc *dsc, stru
       if (dv->z_name[0] != '\0')
 	{
           struct dsc_z_score *z;
-	  char *cp;
 	  struct variable *dst_var;
 
 	  dst_var = dict_create_var_assert (dataset_dict (ds), dv->z_name, 0);
-	  if (dv->v->label)
-	    {
-	      dst_var->label = xmalloc (strlen (dv->v->label) + 12);
-	      cp = stpcpy (dst_var->label, _("Z-score of "));
-	      strcpy (cp, dv->v->label);
-	    }
-	  else
-	    {
-	      dst_var->label = xmalloc (strlen (dv->v->name) + 12);
-	      cp = stpcpy (dst_var->label, _("Z-score of "));
-	      strcpy (cp, dv->v->name);
-	    }
+          var_set_label (dst_var, xasprintf (_("Z-score of %s"),
+                                             var_to_string (dv->v)));
 
           z = &t->z_scores[cnt++];
           z->src_idx = dv->v->fv;
@@ -756,7 +746,7 @@ calc_descriptives (const struct ccase *f
           if (dsc->missing_type != DSC_LISTWISE
               && (x == SYSMIS
                   || (!dsc->include_user_missing
-                      && mv_is_num_user_missing (&dv->v->miss, x))))
+                      && var_is_num_user_missing (dv->v, x))))
             {
               dv->missing += weight;
               continue;
@@ -798,7 +788,7 @@ calc_descriptives (const struct ccase *f
               if (dsc->missing_type != DSC_LISTWISE
                   && (x == SYSMIS
                       || (!dsc->include_user_missing
-                          && mv_is_num_user_missing (&dv->v->miss, x))))
+                          && var_is_num_user_missing (dv->v, x))))
                 continue;
 
               if (dv->moments != NULL)
@@ -864,7 +854,7 @@ listwise_missing (struct dsc_proc *dsc, 
 
       if (x == SYSMIS
           || (!dsc->include_user_missing
-              && mv_is_num_user_missing (&dv->v->miss, x)))
+              && var_is_num_user_missing (dv->v, x)))
         return true;
     }
   return false;
@@ -922,7 +912,7 @@ display (struct dsc_proc *dsc)
       size_t j;
 
       nc = 0;
-      tab_text (t, nc++, i + 1, TAB_LEFT, dv->v->name);
+      tab_text (t, nc++, i + 1, TAB_LEFT, var_get_name (dv->v));
       tab_text (t, nc++, i + 1, TAT_PRINTF, "%g", dv->valid);
       if (dsc->format == DSC_SERIAL)
 	tab_text (t, nc++, i + 1, TAT_PRINTF, "%g", dv->missing);
@@ -949,7 +939,7 @@ descriptives_compare_dsc_vars (const voi
   int result;
 
   if (dsc->sort_by_stat == DSC_NAME)
-    result = strcasecmp (a->v->name, b->v->name);
+    result = strcasecmp (var_get_name (a->v), var_get_name (b->v));
   else 
     {
       double as = a->stats[dsc->sort_by_stat];
Index: src/language/stats/examine.q
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/examine.q,v
retrieving revision 1.17
diff -u -p -r1.17 examine.q
--- src/language/stats/examine.q	25 Nov 2006 02:15:01 -0000	1.17
+++ src/language/stats/examine.q	5 Dec 2006 06:36:50 -0000
@@ -180,7 +180,7 @@ const char *factor_to_string_concise (co
 
 
 /* Function to use for testing for missing values */
-static is_missing_func *value_is_missing;
+static var_is_missing_func *value_is_missing;
 
 
 /* PERCENTILES */
@@ -208,9 +208,9 @@ cmd_examine (struct lexer *lexer, struct
 
   /* If /MISSING=INCLUDE is set, then user missing values are ignored */
   if (cmd.incl == XMN_INCLUDE ) 
-    value_is_missing = mv_is_value_system_missing;
+    value_is_missing = var_is_value_system_missing;
   else
-    value_is_missing = mv_is_value_missing;
+    value_is_missing = var_is_value_missing;
 
   if ( cmd.st_n == SYSMIS ) 
     cmd.st_n = 5;
@@ -678,7 +678,7 @@ factor_calc (struct ccase *c, int case_n
 	  const struct variable *var = dependent_vars[v];
 	  const union value *val = case_data (c, var->fv);
 
-	  if ( value_is_missing (&var->miss, val) || case_missing ) 
+	  if ( value_is_missing (var, val) || case_missing ) 
 	    val = 0;
 	  
 	  metrics_calc ( & (*foo)->m[v], val, weight, case_no);
@@ -740,7 +740,7 @@ run_examine (const struct ccase *first, 
 	      const struct variable *var = dependent_vars[v];
 	      const union value *val = case_data (&c, var->fv);
 
-	      if ( value_is_missing (&var->miss, val))
+	      if ( value_is_missing (var, val))
 		case_missing = 1;
 		   
 	    }
@@ -751,7 +751,7 @@ run_examine (const struct ccase *first, 
 	  const struct variable *var = dependent_vars[v];
 	  const union value *val = case_data (&c, var->fv);
 
-	  if ( value_is_missing (&var->miss, val) || case_missing ) 
+	  if ( value_is_missing (var, val) || case_missing ) 
 	    val = 0;
 
 	  metrics_calc (&totals[v], val, weight, case_no);
@@ -1023,7 +1023,7 @@ show_summary (struct variable **dependen
 	      static union value prev;
 	      
 	      if ( 0 != compare_values (&prev, & (*fs)->id[0], 
-				       fctr->indep_var[0]->width))
+                                        var_get_width (fctr->indep_var[0])))
 		{
 		  tab_text (tbl, 
 			    1,
@@ -1196,7 +1196,7 @@ show_extremes (struct variable **depende
 
 
 	      if ( 0 != compare_values (&prev, & (*fs)->id[0], 
-				       fctr->indep_var[0]->width))
+                                        var_get_width (fctr->indep_var[0])))
 		{
 		  
 		  if ( count > 0 ) 
@@ -1434,7 +1434,7 @@ show_descriptives (struct variable **dep
 
 
 	      if ( 0 != compare_values (&prev, & (*fs)->id[0], 
-				       fctr->indep_var[0]->width))
+                                        var_get_width (fctr->indep_var[0])))
 		{
 		  
 		  if ( count > 0 ) 
@@ -2062,7 +2062,7 @@ show_percentiles (struct variable **depe
 
 
 	      if ( 0 != compare_values (&prev, & (*fs)->id[0], 
-				       fctr->indep_var[0]->width))
+                                        var_get_width (fctr->indep_var[0])))
 		{
 		  
 		  if ( count > 0 ) 
Index: src/language/stats/flip.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/flip.c,v
retrieving revision 1.15
diff -u -p -r1.15 flip.c
--- src/language/stats/flip.c	25 Nov 2006 02:15:01 -0000	1.15
+++ src/language/stats/flip.c	5 Dec 2006 06:36:51 -0000
@@ -301,7 +301,7 @@ flip_sink_create (struct dictionary *dic
   /* Write variable names as first case. */
   for (i = 0; i < flip->var_cnt; i++) 
     buf_copy_str_rpad (flip->output_buf[i].s, MAX_SHORT_STRING,
-                       flip->var[i]->name);
+                       var_get_name (flip->var[i]));
   if (fwrite (flip->output_buf, sizeof *flip->output_buf,
               flip->var_cnt, flip->file) != (size_t) flip->var_cnt) 
     {
@@ -328,7 +328,7 @@ flip_sink_write (struct case_sink *sink,
     {
       struct varname *v = pool_alloc (flip->pool, sizeof *v);
       v->next = NULL;
-      if (flip->new_names->type == NUMERIC) 
+      if (var_is_numeric (flip->new_names))
         {
           double f = case_num (c, flip->idx_to_fv[flip->new_names->index]);
 
@@ -343,7 +343,7 @@ flip_sink_write (struct case_sink *sink,
         }
       else
 	{
-	  int width = MIN (flip->new_names->width, MAX_SHORT_STRING);
+	  int width = MIN (var_get_width (flip->new_names), MAX_SHORT_STRING);
 	  memcpy (v->name, case_str (c, flip->idx_to_fv[flip->new_names->index]),
                   width);
 	  v->name[width] = 0;
@@ -361,7 +361,7 @@ flip_sink_write (struct case_sink *sink,
     {
       double out;
       
-      if (flip->var[i]->type == NUMERIC)
+      if (var_is_numeric (flip->var[i]))
         out = case_num (c, flip->idx_to_fv[flip->var[i]->index]);
       else
         out = SYSMIS;
Index: src/language/stats/frequencies.q
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/frequencies.q,v
retrieving revision 1.23
diff -u -p -r1.23 frequencies.q
--- src/language/stats/frequencies.q	25 Nov 2006 02:15:01 -0000	1.23
+++ src/language/stats/frequencies.q	5 Dec 2006 06:36:51 -0000
@@ -585,7 +585,7 @@ precalc (const struct ccase *first, void
           hsh_hash_func *hash;
 	  hsh_compare_func *compare;
 
-	  if (v->type == NUMERIC) 
+	  if (var_is_numeric (v))
             {
               hash = hash_value_numeric;
               compare = compare_value_numeric_a; 
@@ -722,7 +722,7 @@ not_missing (const void *f_, const void 
   const struct freq *f = f_;
   const struct variable *v = v_;
 
-  return !mv_is_value_missing (&v->miss, f->v);
+  return !var_is_value_missing (v, f->v);
 }
 
 /* Summarizes the frequency table data for variable V. */
@@ -738,7 +738,7 @@ postprocess_freq_tab (struct variable *v
 
   ft = &get_var_freqs (v)->tab;
   assert (ft->mode == FRQM_GENERAL);
-  compare = get_freq_comparator (cmd.sort, v->type);
+  compare = get_freq_comparator (cmd.sort, var_get_type (v));
 
   /* Extract data from hash table. */
   count = hsh_count (ft->data);
@@ -843,13 +843,13 @@ frq_custom_variables (struct lexer *lexe
       if (v->aux != NULL)
 	{
 	  msg (SE, _("Variable %s specified multiple times on VARIABLES "
-		     "subcommand."), v->name);
+		     "subcommand."), var_get_name (v));
 	  return 0;
 	}
-      if (mode == FRQM_INTEGER && v->type != NUMERIC)
+      if (mode == FRQM_INTEGER && !var_is_numeric (v))
         {
           msg (SE, _("Integer mode specified, but %s is not a numeric "
-                     "variable."), v->name);
+                     "variable."), var_get_name (v));
           return 0;
         }
 
@@ -867,12 +867,13 @@ frq_custom_variables (struct lexer *lexe
         vf->tab.vector = NULL;
       vf->n_groups = 0;
       vf->groups = NULL;
-      vf->width = v->width;
-      vf->print = v->print;
+      vf->width = var_get_width (v);
+      vf->print = *var_get_print_format (v);
       if (vf->width > MAX_SHORT_STRING && get_algorithm () == COMPATIBLE) 
         {
+          enum fmt_type type = var_get_print_format (v)->type;
           vf->width = MAX_SHORT_STRING;
-          vf->print.w = MAX_SHORT_STRING * (v->print.type == FMT_AHEX ? 2 : 1);
+          vf->print.w = MAX_SHORT_STRING * (type == FMT_AHEX ? 2 : 1);
         }
     }
   return 1;
@@ -934,14 +935,14 @@ frq_custom_grouped (struct lexer *lexer,
 	for (i = 0; i < n; i++)
           if (v[i]->aux == NULL)
             msg (SE, _("Variables %s specified on GROUPED but not on "
-                       "VARIABLES."), v[i]->name);
+                       "VARIABLES."), var_get_name (v[i]));
           else 
             {
               struct var_freqs *vf = get_var_freqs (v[i]);
                 
               if (vf->groups != NULL)
                 msg (SE, _("Variables %s specified multiple times on GROUPED "
-                           "subcommand."), v[i]->name);
+                           "subcommand."), var_get_name (v[i]));
               else
                 {
                   vf->n_groups = nl;
@@ -1258,9 +1259,8 @@ dump_full (struct variable *v)
   tab_float (t, 2 + lab, r, TAB_NONE, 100.0, 5, 1);
   tab_float (t, 3 + lab, r, TAB_NONE, 100.0, 5, 1);
 
-  tab_title (t, "%s: %s", v->name, v->label ? v->label : "");
+  tab_title (t, "%s", var_to_string (v));
   tab_submit (t);
-
 }
 
 /* Sets the widths of all the columns and heights of all the rows in
@@ -1334,7 +1334,7 @@ dump_condensed (struct variable *v)
 	   cmd.spaces == FRQ_SINGLE ? -1 : TAL_GAP, TAL_1,
 	   0, 0, 3, r - 1);
   tab_hline (t, TAL_2, 0, 3, 2);
-  tab_title (t, "%s: %s", v->name, v->label ? v->label : "");
+  tab_title (t, "%s", var_to_string (v));
   tab_columns (t, SOM_COL_DOWN, 1);
   tab_submit (t);
 }
@@ -1518,13 +1518,13 @@ dump_statistics (struct variable *v, int
   if ( implicit_50th && n_percentiles > 0 ) 
     --n_percentiles;
 
-  if (v->type == ALPHA)
+  if (var_is_alpha (v))
     return;
   ft = &get_var_freqs (v)->tab;
   if (ft->n_valid == 0)
     {
       msg (SW, _("No valid data for variable %s; statistics not displayed."),
-	   v->name);
+	   var_get_name (v));
       return;
     }
   calc_stats (v, stat_value);
@@ -1571,12 +1571,7 @@ dump_statistics (struct variable *v, int
 
   tab_columns (t, SOM_COL_DOWN, 1);
   if (show_varname)
-    {
-      if (v->label)
-	tab_title (t, "%s: %s", v->name, v->label);
-      else
-	tab_title (t, "%s", v->name);
-    }
+    tab_title (t, "%s", var_to_string (v));
   else
     tab_flags (t, SOMF_NO_TITLE);
 
@@ -1603,7 +1598,7 @@ freq_tab_to_hist(const struct freq_tab *
   /* Find out the extremes of the x value */
   for ( frq = hsh_first(fh, &hi); frq != 0; frq = hsh_next(fh, &hi) ) 
     {
-      if ( mv_is_value_missing(&var->miss, frq->v))
+      if ( var_is_value_missing(var, frq->v))
 	continue;
 
       if ( frq->v[0].f < x_min ) x_min = frq->v[0].f ;
Index: src/language/stats/oneway.q
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/oneway.q,v
retrieving revision 1.15
diff -u -p -r1.15 oneway.q
--- src/language/stats/oneway.q	11 Nov 2006 23:10:00 -0000	1.15
+++ src/language/stats/oneway.q	5 Dec 2006 06:36:52 -0000
@@ -867,7 +867,7 @@ precalc ( struct cmd_oneway *cmd UNUSED 
 		   (hsh_compare_func *) compare_group,
 		   (hsh_hash_func *) hash_group,
 		   (hsh_free_func *) free_group,
-		   (void *) indep_var->width );
+		   (void *) var_get_width (indep_var) );
 
 
       totals->sum=0;
@@ -896,7 +896,7 @@ run_oneway(const struct ccase *first, co
 				 (hsh_compare_func *) compare_values,
 				 (hsh_hash_func *) hash_value,
 				 0,
-				 (void *) indep_var->width );
+				 (void *) var_get_width (indep_var) );
 
   precalc(cmd);
 
Index: src/language/stats/rank.q
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/rank.q,v
retrieving revision 1.19
diff -u -p -r1.19 rank.q
--- src/language/stats/rank.q	11 Nov 2006 23:10:00 -0000	1.19
+++ src/language/stats/rank.q	5 Dec 2006 06:36:53 -0000
@@ -148,7 +148,7 @@ struct rank_spec
 
 
 /* Function to use for testing for missing values */
-static is_missing_func *value_is_missing;
+static mv_is_missing_func *value_is_missing;
 
 static struct rank_spec *rank_specs;
 static size_t n_rank_specs;
@@ -216,17 +216,18 @@ create_var_label (struct variable *dest_
       for (g = 0 ; g < n_group_vars ; ++g ) 
 	{
 	  if ( g > 0 ) ds_put_cstr (&group_var_str, " ");
-	  ds_put_cstr (&group_var_str, group_vars[g]->name);
+	  ds_put_cstr (&group_var_str, var_get_name (group_vars[g]));
 	}
 
       ds_put_format (&label, _("%s of %s by %s"), function_name[f], 
-		     src_var->name, ds_cstr (&group_var_str));
+		     var_get_name (src_var), ds_cstr (&group_var_str));
       ds_destroy (&group_var_str);
     }
   else
-    ds_put_format (&label,_("%s of %s"), function_name[f], src_var->name);  
+    ds_put_format (&label, _("%s of %s"),
+                   function_name[f], var_get_name (src_var));  
 
-  dest_var->label = strdup (ds_cstr (&label) );
+  var_set_label (dest_var, ds_cstr (&label));
 
   ds_destroy (&label);
 }
@@ -247,13 +248,13 @@ rank_cmd (struct dataset *ds, const stru
     {
       struct variable *v = dict_get_split_vars (dataset_dict (ds))[i];
       criteria.crits[i].fv = v->fv;
-      criteria.crits[i].width = v->width;
+      criteria.crits[i].width = var_get_width (v);
       criteria.crits[i].dir = SRT_ASCEND;
     }
   for (i = 0; i < n_group_vars; i++) 
     {
       criteria.crits[i + n_splits].fv = group_vars[i]->fv;
-      criteria.crits[i + n_splits].width = group_vars[i]->width;
+      criteria.crits[i + n_splits].width = var_get_width (group_vars[i]);
       criteria.crits[i + n_splits].dir = SRT_ASCEND;
     }
   for (i = 0 ; i < sc->crit_cnt ; ++i )
@@ -279,7 +280,7 @@ rank_cmd (struct dataset *ds, const stru
       out = rank_sorted_casefile (sorted_cf, &criteria,
 				  dataset_dict (ds),
                                   rank_specs, n_rank_specs, 
-				  i, &src_vars[i]->miss)  ;
+				  i, var_get_missing_values (src_vars[i]));
       if ( NULL == out ) 
 	{
 	  result = false ;
@@ -685,8 +686,8 @@ create_rank_variable (struct dictionary 
 
   if ( NULL == var )
     {
-      snprintf(name, SHORT_NAME_LEN + 1, "%c%s", 
-	       function_name[f][0], src_var->name);
+      snprintf (name, SHORT_NAME_LEN + 1, "%c%s", 
+                function_name[f][0], var_get_name (src_var));
   
       var = dict_create_var(dict, name, 0);
     }
@@ -724,7 +725,7 @@ create_rank_variable (struct dictionary 
       return NULL;
     }
 
-  var->write = var->print = dest_format[f];
+  var_set_both_formats (var, &dest_format[f]); 
 
   return var;
 }
@@ -834,7 +835,7 @@ cmd_rank (struct lexer *lexer, struct da
 		  ds_init_empty (&varlist);
 		  for ( g = 0 ; g < n_group_vars ; ++g ) 
 		    {
-		      ds_put_cstr (&varlist, group_vars[g]->name);
+		      ds_put_cstr (&varlist, var_get_name (group_vars[g]));
 
 		      if ( g < n_group_vars - 1)
 			ds_put_cstr (&varlist, " ");
@@ -844,10 +845,10 @@ cmd_rank (struct lexer *lexer, struct da
 		       rank_specs[i].rfunc == PROPORTION ) 
 		    tab_output_text (TAT_PRINTF,
 				     _("%s into %s(%s of %s using %s BY %s)"), 
-				     src_vars[v]->name,
-				     rank_specs[i].destvars[v]->name,
+				     var_get_name (src_vars[v]),
+				     var_get_name (rank_specs[i].destvars[v]),
 				     function_name[rank_specs[i].rfunc],
-				     src_vars[v]->name,
+				     var_get_name (src_vars[v]),
 				     fraction_name(),
 				     ds_cstr (&varlist)
 				     );
@@ -855,10 +856,10 @@ cmd_rank (struct lexer *lexer, struct da
 		  else
 		    tab_output_text (TAT_PRINTF,
 				     _("%s into %s(%s of %s BY %s)"), 
-				     src_vars[v]->name,
-				     rank_specs[i].destvars[v]->name,
+				     var_get_name (src_vars[v]),
+				     var_get_name (rank_specs[i].destvars[v]),
 				     function_name[rank_specs[i].rfunc],
-				     src_vars[v]->name,
+				     var_get_name (src_vars[v]),
 				     ds_cstr (&varlist)
 				     );
 		  ds_destroy (&varlist);
@@ -869,20 +870,20 @@ cmd_rank (struct lexer *lexer, struct da
 		       rank_specs[i].rfunc == PROPORTION ) 
 		    tab_output_text (TAT_PRINTF,
 				     _("%s into %s(%s of %s using %s)"), 
-				     src_vars[v]->name,
-				     rank_specs[i].destvars[v]->name,
+				     var_get_name (src_vars[v]),
+				     var_get_name (rank_specs[i].destvars[v]),
 				     function_name[rank_specs[i].rfunc],
-				     src_vars[v]->name,
+				     var_get_name (src_vars[v]),
 				     fraction_name()
 				     );
 		    
 		  else
 		    tab_output_text (TAT_PRINTF,
 				     _("%s into %s(%s of %s)"), 
-				     src_vars[v]->name,
-				     rank_specs[i].destvars[v]->name,
+				     var_get_name (src_vars[v]),
+				     var_get_name (rank_specs[i].destvars[v]),
 				     function_name[rank_specs[i].rfunc],
-				     src_vars[v]->name
+				     var_get_name (src_vars[v])
 				     );
 		}
 	    }
